package Ha;

import java.io.*;

public class ClassCheck {
    public static int Base64Encode(String path) {
        //  Base64 인코딩 (CryptoClass.java 에서 확인함)
        //  Base64 인코딩 방법은 안전한 인코딩 방법이 아님
        int num = 0;
        try {
            String check = "Base64.encode";

            File f = new File(path);
            FileReader fr = new FileReader(String.valueOf(f));
            BufferedReader bufr = new BufferedReader(fr);
            String line = "";
            while ((line = bufr.readLine()) != null) {
                if (line.contains(check))
                    System.out.println("Base64 인코딩 사용 -> 취약");
                num++;
            }
            bufr.close();
        } catch (FileNotFoundException e) {
            System.out.println("파일을 찾을 수 없음");
        } catch (IOException e) {
            System.out.println(e);
        }
        if(num>0){
            OpenTable ot = new OpenTable();
            ot.update("INSERT INTO result2 (Grade,Name,Content)" + "VALUES(' 상', ' Base64 인코딩',' Base64 인코딩 사용 ') ");
            ot.update("INSERT INTO result2 (Grade,Name,Content)" + "VALUES(' 상', ' Base64 인코딩2',' 안전하지 않은 인코딩 사용') ");
            return 1;
        }
        else return 0;
    }

    public static int Base64Decode(String path) {
        //  Base64 디코드 (CryptoClass.java 에서 확인함)
        int num = 0;
        try {
            String check = "Base64.decode";

            File f = new File(path);
            FileReader fr = new FileReader(String.valueOf(f));
            BufferedReader bufr = new BufferedReader(fr);
            String line = "";
            while ((line = bufr.readLine()) != null) {
                if (line.contains(check))
                    System.out.println("Base64 디코드 사용 -> 취약");
                num++;
            }
            bufr.close();
        } catch (FileNotFoundException e) {
            System.out.println("파일을 찾을 수 없음");
        } catch (IOException e) {
            System.out.println(e);
        }
        if(num>0){
            OpenTable ot = new OpenTable();
            ot.update("INSERT INTO result2 (Grade,Name,Content)" + "VALUES(' 상', ' Base64 디코드',' Base64 디코드 사용 ') ");
            ot.update("INSERT INTO result2 (Grade,Name,Content)" + "VALUES(' 상', ' Base64 디코드2',' 안전하지 않은 디코드 사용 ') ");
            return 1;
        }
        else return 0;
    }

    public static int SMS(String path) {
        //  사용자 몰래 sms,mms 보내는지 체크 (MyBroadCastReceiver.java에서 확인함)
        int num = 0;
        try {
            String check = "SmsManager";

            File f = new File(path);
            FileReader fr = new FileReader(String.valueOf(f));
            BufferedReader bufr = new BufferedReader(fr);
            String line = "";
            while ((line = bufr.readLine()) != null) {
                if (line.contains(check))
                    System.out.println("SmsManager 사용 -> 취약");
                num++;
            }
            bufr.close();
        } catch (FileNotFoundException e) {
            System.out.println("파일을 찾을 수 없음");
        } catch (IOException e) {
            System.out.println(e);
        }
        if(num>0){
            OpenTable ot = new OpenTable();
            ot.update("INSERT INTO result2 (Grade,Name,Content)" + "VALUES(' 상', ' SMS 체크',' SmsManager 사용 ') ");
            ot.update("INSERT INTO result2 (Grade,Name,Content)" + "VALUES(' 상', ' SMS 체크2',' 사용자 몰래 sms,mms 전송 허가 ') ");
            return 1;
        }
        else return 0;
    }

    public static int Catch(String path) {
        //  catch의 일반 예외
        //예외 포착은 구체적이어야합니다. 일반 예외 유형이 안전하지 않아 자동 오류 방지로 이어짐
        int num = 0;
        try {
            String check = "catch (Exception paramContext)";

            File f = new File(path);
            FileReader fr = new FileReader(String.valueOf(f));
            BufferedReader bufr = new BufferedReader(fr);
            String line = "";
            while ((line = bufr.readLine()) != null) {
                if (line.contains(check))
                    System.out.println("catch 예약 취약");
                num++;
            }
            bufr.close();
        } catch (FileNotFoundException e) {
            System.out.println("파일을 찾을 수 없음");
        } catch (IOException e) {
            System.out.println(e);
        }
        if(num>0){
            OpenTable ot = new OpenTable();
            ot.update("INSERT INTO result2 (Grade,Name,Content)" + "VALUES(' 상', ' catch의 일반 예외',' catch 예약 취약 ') ");
            ot.update("INSERT INTO result2 (Grade,Name,Content)" + "VALUES(' 상', ' catch의 일반 예외2',' 구체적이지 않은 예외 포착 ') ");
            return 1;
        }
        else return 0;
    }

    public static int Log(String path) {
        //  로그에서 확인되지 않은 출력
        //  민감한 정보는 정보가 공개 될 수 있으므로 기록해서는 안됩니다.
        int num = 0;
        try {
            String check = "username + \":\" + DoLogin.this.password)";

            File f = new File(path);
            FileReader fr = new FileReader(String.valueOf(f));
            BufferedReader bufr = new BufferedReader(fr);
            String line = "";
            while ((line = bufr.readLine()) != null) {
                if (line.contains(check))
                    System.out.println("민감정보 로그 취약");
                num++;
            }
            bufr.close();
        } catch (FileNotFoundException e) {
            System.out.println("파일을 찾을 수 없음");
        } catch (IOException e) {
            System.out.println(e);
        }
        if(num>0){
            OpenTable ot = new OpenTable();
            ot.update("INSERT INTO result2 (Grade,Name,Content)" + "VALUES(' 상', ' 로그 확인',' 민감정보 로그 취약 ') ");
            ot.update("INSERT INTO result2 (Grade,Name,Content)" + "VALUES(' 상', ' 로그 확인2',' 로그에서 확인되지 않은 출력 확인 ') ");
            return 1;
        }
        else return 0;
    }

    public static int findExternalStorage(String path){
        //Class파일에서 외부 저장소에서 쓰기 읽기 취약점
        String word = "(?i).*getExternalStorage.*";
        int num=0; int num1=0;
        try {
            BufferedReader reader = new BufferedReader(new FileReader(path));
            String s;

            int line =1;

            while ((s = reader.readLine()) != null) {
                if (s.matches(word)){
                    //System.out.println(line + " : " + s);
                    num++;
                }
                line++; }
        } catch (FileNotFoundException e) { e.printStackTrace(); }
        catch (IOException e) { e.printStackTrace(); }
        if(num>0){
            System.out.println("외부저장소 쓰기 읽기 사용 -> 취약"); num1++;
                OpenTable ot = new OpenTable();
                ot.update("INSERT INTO result2 (Grade,Name,Content)" + "VALUES(' 상', ' 외부저장소 쓰기 읽기',' 외부저장소의 중요한 정보 노출 가능 ') ");

            return 1; }
        else
            return 0;

    }

    public static int PostLogin_Rooting(String path2) {
        // 루팅탐지 (PostLogin.java 파일에서 확인 가능)
        // 사용자가 Root권한을 획득하여 시스템을 사용가능
        int num = 0;
        try {
            int i = 0;
            int count = 0;
            String check = "/system/app/Superuser.apk";

            File f = new File(path2);
            FileReader fr = new FileReader(String.valueOf(f));
            BufferedReader bufr = new BufferedReader(fr);
            String line = "";
            while ((line = bufr.readLine()) != null) {
                if (line.contains(check))
                    // 라인 중 /system/app/Superuser.apk 포함한 라인 찾음
                    i++;
                count = i;
            }
            if (i > 0)
            {
                System.out.println("노출된 루팅 갯수 : "+count+" -> 취약");
                num++;
                if(num>0){
                    OpenTable ot = new OpenTable();
                    ot.update("INSERT INTO result2 (Grade,Name,Content)" + "VALUES(' 상', ' 루팅탐지',' 노출된 루팅 갯수 : "+count+"') ");
                    ot.update("INSERT INTO result2 (Grade,Name,Content)" + "VALUES(' 상', ' 루팅탐지2',' Root권한 획득 가능') ");
                }
            }
            bufr.close();
        } catch (FileNotFoundException e) {
            System.out.println("파일을 찾을 수 없음");
        } catch (IOException e) {
            System.out.println(e);
        }
        if(num>0)
            return 1;
        else
            return 0;
    }

    public static int PostLogin_Su(String path2) {
        // Su 권한 확인 (PostLogin.java 파일에서 확인 가능)
        // 응용 프로그램이 시스템 명령을 실행할 수 있습니다.
        int num = 0;
        try {
            String check = "/system/xbin/which\", \"su";

            File f = new File(path2);
            FileReader fr = new FileReader(String.valueOf(f));
            BufferedReader bufr = new BufferedReader(fr);
            String line = "";
            while ((line = bufr.readLine()) != null) {
                if (line.contains(check))
                    // 라인 중 "/system/xbin/which", "su" 포함한 라인 찾음
                    System.out.println("시스템 명령 실행중 -> 취약");
                num++;
            }
            bufr.close();
        } catch (FileNotFoundException e) {
            System.out.println("파일을 찾을 수 없음");
        } catch (IOException e) {
            System.out.println(e);
        }
        if(num>0){
            OpenTable ot = new OpenTable();
            ot.update("INSERT INTO result2 (Grade,Name,Content)" + "VALUES(' 상', ' Su 권한',' 시스템 명령 실행중 ') ");
            ot.update("INSERT INTO result2 (Grade,Name,Content)" + "VALUES(' 상', ' Su 권한2',' 응용 프로그램이 시스템 명령 실행 가능 ') ");
            return 1;
        }
        else
            return 0;
    }


}
